/*
 * does iterative, recursive mergesort
 * must be compiled with sorters.cs
 */

import java.util.ArrayList;
import java.util.Collections;

public class SortTester {
    // instance variables - replace the example below with your own
    private static IntList nums;
    private static int LISTSIZE = 100000;
    private static int MAXSAFE  = 1073741824;
    private static long starttime, elapsedMilliseconds;

    public static void main(String[] args) {
        if (args.length > 0) {
            LISTSIZE = new Integer(args[0]);
            System.out.println("List size is " + LISTSIZE);
        }
        nums = new IntList(LISTSIZE);
        IntList nums1 = new IntList(LISTSIZE);
        IntList nums2 = new IntList(LISTSIZE);
        IntList nums3 = new IntList(LISTSIZE);

        ArrayList<Integer> mnums = new ArrayList<Integer>(LISTSIZE);    // Java list
    /*
    IntList nums2 = new IntList(10);
    nums2.add(5); nums2.add(14); nums2.add(6); nums2.add(5); nums2.add(4);
    nums2.add(8); nums2.add(3); nums2.add(12); nums2.add(7); nums2.add(5);
    /* */
        nums.RandomFill(MAXSAFE);
        //nums.RandomFill();
        for (int i=0; i<LISTSIZE; i++) {
            nums1.add(nums.get(i));
            nums2.add(nums.get(i));
            nums3.add(nums.get(i));
            mnums.add(nums.get(i));
        }

        //  ***********  selection sort ******************
    /*
    starttime = System.currentTimeMillis();
    System.out.printf("starting selection sort of %d numbers%n", LISTSIZE);
    nums.ssort();
    //s.Stop();
    if (!nums.checksort()) System.out.println("sort failed!");
    else System.out.println("sorting was successful!");
    elapsedMilliseconds = System.currentTimeMillis() - starttime;
    System.out.println("sorting took " + elapsedMilliseconds + " ms");
    /* */
        //  ***********  insertion sort ******************
    /* */
        starttime = System.currentTimeMillis();
        System.out.printf("starting insertion sort of %d numbers%n", LISTSIZE);
        nums1.isort();
        //s.Stop();
        if (!nums1.checksort()) System.out.println("sort failed!");
        else System.out.println("sorting was successful!");
        elapsedMilliseconds = System.currentTimeMillis() - starttime;
        System.out.println("sorting took " + elapsedMilliseconds + " ms");
    /* */
        //  ***********  RECURSIVE mergesort ******************
    /* */
        System.out.println("starting recursive mergesort of " + LISTSIZE + " numbers");
        starttime = System.currentTimeMillis();
        //nums2.qsort2();
        nums2.rmsort();
        elapsedMilliseconds = System.currentTimeMillis() - starttime;
        //nums.print();
        if (!nums2.checksort()) {
            System.out.println("sort failed!");
            nums.print();
        } else System.out.println("sorting was successful!");
        System.out.printf("sorting took %d ms%n", elapsedMilliseconds);
    /* */

        System.out.printf("starting Java Collections.sort() of %d numbers%n", LISTSIZE);
        starttime = System.currentTimeMillis();
        Collections.sort(mnums);
        elapsedMilliseconds = System.currentTimeMillis() - starttime;
        //if (!nums.checksort()) System.out.println("sort failed!");
        //else System.out.println("sorting was successful!");
        System.out.printf("sorting took %d ms%n", elapsedMilliseconds);
    /* */
    }
}